package pl_encoding;

use Exporter;
use strict 'vars';

our @ISA=qw(Exporter);

our @EXPORT=qw(%sign_short %encoding %sign_name %def_name %neg &defs);

our %sign_short=(
		'111' => 'a',
		'000' => 'c',
		'100' => 'n',
		'010' => '0',
		'001' => 'p',
		'110' => 'l',
		'011' => 'g',
		'101' => 'u');

our %encoding= map  ( ($sign_short{$_} => $_ ) , keys(%sign_short));


our %sign_name=('a' => 'any',
	    'c' => 'none',
	    'n' => 'neg',
	    'p' => 'pos',
	    '0' => 'zero',
	    'l' => 'nonpos',
	    'g' => 'nonneg',
	    'u' => 'nonzero');

our %def_name= map(( $_ => "SIGN_".uc($sign_name{$_})) , 
		    keys(%sign_name));

our %neg=('a' => 'a',
	 'c' => 'c',
	 'n' => 'p',
	 'p' => 'n',
	 '0' => '0',
	 'l' => 'g',
	 'g' => 'l',
	 'u' => 'u');

sub to_num{
  my $str=shift;
  my @bits=reverse(split("",$str));
  return $bits[0]+2*$bits[1]+4*$bits[2];
}
sub defs {
  printf "/* Autogenerated by pl_encoding.pm  %s */\n",scalar(localtime());
  print qq{#ifndef SIGN_ENCODING_H
#define SIGN_ENCODING_H
};	   
  my @enums=();
  my %name=();
  for my $k (keys(%encoding)){
    my $num=to_num($encoding{$k});
    $name{$num}=$sign_name{$k};
    push(@enums, "$def_name{$k}=$num /* $encoding{$k} */");
  }
  print "typedef enum sign_encoding_enum{\n ";
  print join(",\n",@enums);
  print "} nu_sign_t,*nu_sign_p;\n";
  print "#define SIGN_BITWIDTH 3\n";
  
  print "#define PL_ROW_UNKNOWN ( (1 << (6*SIGN_BITWIDTH))-1)\n";
  print "#ifdef DEFINE_SIGN_NAMES\n";
  print "const char *sign_name[]={\n";
  for my $i (sort (keys %name)){
    printf '"%s",',$name{$i};
    print "\n";
  }
  print "};\n";
  print "#else\n";
  print "extern const char *sign_name[];\n";
  print "#endif\n";
  print "#endif\n";
}

1;
