#!/usr/bin/perl -w

use strict;
use warnings;
use Getopt::Std;
my $count=0;
my %decl=();
my %options=();


sub usage(){
  print STDERR "$0 [-o outfile]  file1.h file2.h...\n";
  exit(1);
}
    

getopt('o:h',\%options);

$options{h} && usage();

my $outfile=$options{o} || "-";

while (<>){
  if (m|void\s+(\w+)\b.*/\*NA_FUNC\*/|){
    $decl{$1}=$_	if (!defined($decl{$1}));
  }
}

my @name=sort keys %decl;

open(H,">$outfile") || die;

printf H "# This file generated by $0 %s\n",scalar(localtime);
my $i;

for ($i=0; $i<scalar(@name); $i++){
  print H "$name[$i]\n";
}



