#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include "debug.h"
#include "oms_opt.h"
#include "profile.h"
#include "shutdown.h"
#include "gparams.h"
#include "nalloc.h"
#include "globaldef.h"
void   shutdown(na_node_p global,char *funct, char *fmt, ...)
{
  va_list args;
  params_p params=na_access(global,SLOT(params));
  /*
  ** Display the name of the function that called us
  */
  if (ERR_DEBUG_MASK & DB_SHUTDOWN){
    fprintf(stderr, "%s: ", funct);
    /*
    ** Display the remainder of the message
    */
    va_start(args, fmt);
    vfprintf(stderr, fmt, args);
    va_end(args);
    fprintf(stderr,"\n\n");

  }
#ifdef USE_DMALLOC
  dmalloc_shutdown();
#endif
 output_finish(params);
 prof_dump(params->profile_level);

 exit(0);

}
